Pair (Apache Commons Lang 3.17.0 API)
Description: declaration: package: org.apache.commons.lang3.tuple, class: Pair

Package org.apache.commons.lang3.tuple

# Class Pair<L,R>

java.lang.Object
org.apache.commons.lang3.tuple.Pair<L,R>

Type Parameters:
  `L` - the left element type
  `R` - the right element type

All Implemented Interfaces:
  `Serializable`, `Comparable<Pair<L,R>>`, `Map.Entry<L,R>`

Direct Known Subclasses:
  `Diff`, `ImmutablePair`, `MutablePair`

public abstract class Pair<L,R> extends Object implements Map.Entry<L,R>, Comparable<Pair<L,R>>, Serializable
A pair consisting of two elements.

This class is an abstract implementation defining the basic API. It refers to the elements as 'left' and 'right'. It also implements the `Map.Entry` interface where the key is 'left' and the value is 'right'.

Subclass implementations may be mutable or immutable. However, there is no restriction on the type of the stored objects that may be stored. If mutable objects are stored in the pair, then the pair itself effectively becomes mutable.

Since:
  3.0
See Also:
  - Serialized Form

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `static final Pair<?,?>[]`
  `EMPTY_ARRAY`
  An empty array.

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `Pair()`
  Constructs a new instance.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `<E extends Throwable>
  void`
  `accept(FailableBiConsumer<L,R,E> consumer)`
  Accepts this key and value as arguments to the given consumer.
  `<V, E extends Throwable>
  V`
  `apply(FailableBiFunction<L,R,V,E> function)`
  Applies this key and value as arguments to the given function.
  `int`
  `compareTo(Pair<L,R> other)`
  Compares the pair based on the left element followed by the right element.
  `static <L, R> Pair<L,R>[]`
  `emptyArray()`
  Returns the empty array singleton that can be assigned without compiler warning.
  `boolean`
  `equals(Object obj)`
  Compares this pair to another based on the two elements.
  `final L`
  `getKey()`
  Gets the key from this pair.
  `abstract L`
  `getLeft()`
  Gets the left element from this pair.
  `abstract R`
  `getRight()`
  Gets the right element from this pair.
  `R`
  `getValue()`
  Gets the value from this pair.
  `int`
  `hashCode()`
  Returns a suitable hash code.
  `static <L, R> Pair<L,R>`
  `of(Map.Entry<L,R> pair)`
  Creates an immutable pair from a map entry.
  `static <L, R> Pair<L,R>`
  `of(L left, R right)`
  Creates an immutable pair of two objects inferring the generic types.
  `static <L, R> Pair<L,R>`
  `ofNonNull(L left, R right)`
  Creates an immutable pair of two non-null objects inferring the generic types.
  `String`
  `toString()`
  Returns a String representation of this pair using the format `($left,$right)`.
  `String`
  `toString(String format)`
  Formats the receiver using the given format.

  ### Methods inherited from class java.lang.Object

  `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

  ### Methods inherited from interface java.util.Map.Entry

  `setValue`

- ## Field Details

  - ### EMPTY_ARRAY

    public static final Pair<?,?>[] EMPTY_ARRAY
    An empty array.

    Consider using `emptyArray()` to avoid generics warnings.

    Since:
      3.10.

- ## Constructor Details

  - ### Pair

    public Pair()
    Constructs a new instance.

- ## Method Details

  - ### emptyArray

    public static <L, R> Pair<L,R>[] emptyArray()
    Returns the empty array singleton that can be assigned without compiler warning.
    Type Parameters:
      `L` - the left element type
      `R` - the right element type
    Returns:
      the empty array singleton that can be assigned without compiler warning.
    Since:
      3.10.

  - ### of

    public static <L, R> Pair<L,R> of(L left, R right)
    Creates an immutable pair of two objects inferring the generic types.

    This factory allows the pair to be created using inference to obtain the generic types.

    Type Parameters:
      `L` - the left element type
      `R` - the right element type
    Parameters:
      `left` - the left element, may be null
      `right` - the right element, may be null
    Returns:
      a pair formed from the two parameters, not null

  - ### of

    public static <L, R> Pair<L,R> of(Map.Entry<L,R> pair)
    Creates an immutable pair from a map entry.

    This factory allows the pair to be created using inference to obtain the generic types.

    Type Parameters:
      `L` - the left element type
      `R` - the right element type
    Parameters:
      `pair` - the map entry.
    Returns:
      a pair formed from the map entry
    Since:
      3.10

  - ### ofNonNull

    public static <L, R> Pair<L,R> ofNonNull(L left, R right)
    Creates an immutable pair of two non-null objects inferring the generic types.

    This factory allows the pair to be created using inference to obtain the generic types.

    Type Parameters:
      `L` - the left element type
      `R` - the right element type
    Parameters:
      `left` - the left element, may not be null
      `right` - the right element, may not be null
    Returns:
      a pair formed from the two parameters, not null
    Throws:
      `NullPointerException` - if any input is null
    Since:
      3.13.0

  - ### accept

    public <E extends Throwable> void accept(FailableBiConsumer<L,R,E> consumer) throws E
    Accepts this key and value as arguments to the given consumer.
    Type Parameters:
      `E` - The kind of thrown exception or error.
    Parameters:
      `consumer` - the consumer to call.
    Throws:
      `E` - Thrown when the consumer fails.
    Since:
      3.13.0

  - ### apply

    public <V, E extends Throwable> V apply(FailableBiFunction<L,R,V,E> function) throws E
    Applies this key and value as arguments to the given function.
    Type Parameters:
      `V` - The function return type.
      `E` - The kind of thrown exception or error.
    Parameters:
      `function` - the consumer to call.
    Returns:
      the function's return value.
    Throws:
      `E` - Thrown when the consumer fails.
    Since:
      3.13.0

  - ### compareTo

    public int compareTo(Pair<L,R> other)
    Compares the pair based on the left element followed by the right element. The types must be `Comparable`.
    Specified by:
      `compareTo` in interface `Comparable<L>`
    Parameters:
      `other` - the other pair, not null
    Returns:
      negative if this is less, zero if equal, positive if greater

  - ### equals

    public boolean equals(Object obj)
    Compares this pair to another based on the two elements.
    Specified by:
      `equals` in interface `Map.Entry<L,R>`
    Overrides:
      `equals` in class `Object`
    Parameters:
      `obj` - the object to compare to, null returns false
    Returns:
      true if the elements of the pair are equal

  - ### getKey

    public final L getKey()
    Gets the key from this pair.

    This method implements the `Map.Entry` interface returning the left element as the key.

    Specified by:
      `getKey` in interface `Map.Entry<L,R>`
    Returns:
      the left element as the key, may be null

  - ### getLeft

    public abstract L getLeft()
    Gets the left element from this pair.

    When treated as a key-value pair, this is the key.

    Returns:
      the left element, may be null

  - ### getRight

    public abstract R getRight()
    Gets the right element from this pair.

    When treated as a key-value pair, this is the value.

    Returns:
      the right element, may be null

  - ### getValue

    public R getValue()
    Gets the value from this pair.

    This method implements the `Map.Entry` interface returning the right element as the value.

    Specified by:
      `getValue` in interface `Map.Entry<L,R>`
    Returns:
      the right element as the value, may be null

  - ### hashCode

    public int hashCode()
    Returns a suitable hash code. The hash code follows the definition in `Map.Entry`.
    Specified by:
      `hashCode` in interface `Map.Entry<L,R>`
    Overrides:
      `hashCode` in class `Object`
    Returns:
      the hash code

  - ### toString

    public String toString()
    Returns a String representation of this pair using the format `($left,$right)`.
    Overrides:
      `toString` in class `Object`
    Returns:
      a string describing this object, not null

  - ### toString

    public String toString(String format)
    Formats the receiver using the given format.

    This uses `Formattable` to perform the formatting. Two variables may be used to embed the left and right elements. Use `%1$s` for the left element (key) and `%2$s` for the right element (value). The default format used by `toString()` is `(%1$s,%2$s)`.

    Parameters:
      `format` - the format string, optionally containing `%1$s` and `%2$s`, not null
    Returns:
      the formatted string, not null